#pragma once
#include <list>
#include "ship.h"
#include "ship_type.h"

class AIShip: public Ship {
public:
  OBJDEF(AIShip, Ship, AISHIP);
  AIShip(ShipType::Type shipType): Ship(shipType) { }
  AIShip(void): Ship() { }
  void TimeStepUpdate(const float timeStep);

  enum Command { DO_NOTHING, DO_KILL };
  void Instruct(enum Command, void* arg);
  void ClearInstructions(void) { m_todo.clear(); }
  virtual void PostLoadFixup(void);

protected:
  virtual void Save(void);
  virtual void Load(void);
private:
  bool DoKill(const Ship*);
  class Instruction {
  public:
    Command cmd;
    void* arg;
    Instruction(Command c, void* a): cmd(c), arg(a) { }
  };

  std::list<Instruction> m_todo;
};

